<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 4 $
 * $Id: EditClient.php 4 2006-08-07 23:04:34Z ipso $
 * $Date: 2006-08-07 16:04:34 -0700 (Mon, 07 Aug 2006) $
 */
require_once('../../includes/global.inc.php');
require_once(Environment::getBasePath() .'includes/Interface.inc.php');

if ( !$permission->Check('client','enabled')
		OR !( $permission->Check('client','edit') OR $permission->Check('client','edit_own') ) ) {

	$permission->Redirect( FALSE ); //Redirect

}

$title = 'Edit Client';
$smarty->assign('title', $title);
BreadCrumb::setCrumb($title);

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'client_id',
												'data',
												'data_saved'
												) ) );

$cf = new ClientFactory();
$action = strtolower($action);
switch ($action) {
	case 'submit':
		Debug::Text('Submit!', __FILE__, __LINE__, __METHOD__,10);

		$cf->setId($data['client_id']);
		$cf->setCompany( $current_user->getCompany() );
		$cf->setStatus($data['status_id']);
		$cf->setGroup($data['group_id']);
		$cf->setSalesContact($data['sales_contact_id']);
		$cf->setSupportContact($data['support_contact_id']);
		$cf->setCompanyName($data['company_name']);
		$cf->setWebsite($data['website']);
		$cf->setNote($data['note']);

		if ( isset($data['other_id1']) ) {
			$cf->setOtherID1( $data['other_id1'] );
		}
		if ( isset($data['other_id2']) ) {
			$cf->setOtherID2( $data['other_id2'] );
		}
		if ( isset($data['other_id3']) ) {
			$cf->setOtherID3( $data['other_id3'] );
		}
		if ( isset($data['other_id4']) ) {
			$cf->setOtherID4( $data['other_id4'] );
		}
		if ( isset($data['other_id5']) ) {
			$cf->setOtherID5( $data['other_id5'] );
		}

		if ( $cf->isValid() ) {
			$cf->Save();

			Redirect::Page( URLBuilder::getURL( array('client_id' => $data['client_id'], 'data_saved' => TRUE), 'EditClient.php') );

			break;
		}
	default:
		if ( isset($client_id) AND $action != 'submit') {
			unset($client_data);

			Debug::Text('Client ID: '. $client_id, __FILE__, __LINE__, __METHOD__,10);
			$clf = new ClientListFactory();

			//$uwlf->GetByUserIdAndCompanyId($current_user->getId(), $current_company->getId() );
			$clf->getById($client_id);

			foreach ($clf as $c_obj) {
				$data = array(
									'id' => $c_obj->getId(),
									'status_id' => $c_obj->getStatus(),
									'group_id' => $c_obj->getGroup(),
									'sales_contact_id' => $c_obj->getSalesContact(),
									'support_contact_id' => $c_obj->getSupportContact(),
									'company_id' => $c_obj->getCompany(),
									'company_name' => $c_obj->getCompanyName(),
									'website' => $c_obj->getWebsite(),
									'note' => $c_obj->getNote(),
									'other_id1' => $c_obj->getOtherID1(),
									'other_id2' => $c_obj->getOtherID2(),
									'other_id3' => $c_obj->getOtherID3(),
									'other_id4' => $c_obj->getOtherID4(),
									'other_id5' => $c_obj->getOtherID5(),
									'created_date' => $c_obj->getCreatedDate(),
									'created_by' => $c_obj->getCreatedBy(),
									'updated_date' => $c_obj->getUpdatedDate(),
									'updated_by' => $c_obj->getUpdatedBy(),
									'deleted_date' => $c_obj->getDeletedDate(),
									'deleted_by' => $c_obj->getDeletedBy()
								);
			}
		}

		$data['status_options'] = $cf->getOptions('status');
		$data['user_list_options'] = UserListFactory::getByCompanyIdArray($current_company->getId());

		$data['client_options'] = ClientListFactory::getByCompanyIdArray( $current_company->getId(), TRUE );

		$cglf = new ClientGroupListFactory();
		$nodes = FastTree::FormatArray( $cglf->getByCompanyIdArray( $current_company->getId() ), 'TEXT', TRUE);

		foreach($nodes as $node) {
			$data['group_options'][$node['id']] = $node['text'];
		}

		//Get other field names
		$oflf = new OtherFieldListFactory();
		$data['other_field_names'] = $oflf->getByCompanyIdAndTypeIdArray( $current_company->getId(), 50 );

		$smarty->assign_by_ref('data', $data);
		$smarty->assign_by_ref('client_id', $client_id);
		$smarty->assign_by_ref('data_saved', $data_saved );

		break;
}

$smarty->assign_by_ref('cf', $cf);

$smarty->display('client/EditClient.tpl');
?>