<?php
/*********************************************************************************
 * The contents of this file are subject to the TimeTrex Public License Version
 * 1.1.0 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.TimeTrex.com/TPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by TimeTrex" logo and
 *    (ii) the TimeTrex copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: TimeTrex Open Source
 * The Initial Developer of the Original Code is TimeTrex Payroll Services
 * Portions created by TimeTrex are Copyright (C) 2004-2007 TimeTrex Payroll Services;
 * All Rights Reserved.
 *
 ********************************************************************************/
/*
 * $Revision: 417 $
 * $Id: ActiveShiftList.php 417 2006-12-06 22:58:53Z ipso $
 * $Date: 2006-12-06 14:58:53 -0800 (Wed, 06 Dec 2006) $
 */
require_once('../../includes/global.inc.php');
require_once(Environment::getBasePath() .'includes/Interface.inc.php');

//Debug::setVerbosity(11);

if ( !$permission->Check('report','enabled')
		OR !$permission->Check('report','view_active_shift') ) {
	$permission->Redirect( FALSE ); //Redirect
}

$title = 'Whos In';
$smarty->assign('title', $title);
BreadCrumb::setCrumb($title);

/*
 * Get FORM variables
 */
extract	(FormVariables::GetVariables(
										array	(
												'action',
												'page',
												'sort_column',
												'sort_order'
												) ) );

URLBuilder::setURL($_SERVER['SCRIPT_NAME'],
											array(
													'sort_column' => $sort_column,
													'sort_order' => $sort_order,
													'page' => $page
												) );

switch (strtolower($action)) {
	default:
		$ulf = new UserListFactory();
		//$sslf = new ScheduleShiftListFactory();
		//$slf = new ShiftListFactory();
		$plf = new PunchListFactory();

		$ulf->getByCompanyID($current_company->getID(), 50, $page, array($sort_column => $sort_order) );

		$pager = new Pager($ulf);

		$blf = new BranchListFactory();
		$branch_options = $blf->getByCompanyIdArray( $current_company->getId() );

		$dlf = new DepartmentListFactory();
		$department_options = $dlf->getByCompanyIdArray( $current_company->getId() );

		//$type_options = $sslf->getOptions( 'type' );

		$epoch = TTDate::getTime();

		foreach ($ulf as $user) {
			if ( $user->getStatus() != 10 ) {
				continue;
			}

			$plf->getPreviousPunchByUserIdAndEpoch( $user->getId(), $epoch );
			if ( $plf->getRecordCount() > 0 ) {
				$prev_p_obj = $plf->getCurrent();


				$punch_data = array(
										'punch_id' => $prev_p_obj->getId(),
										'time_stamp' => $prev_p_obj->getTimeStamp(),
										'status_id' => $prev_p_obj->getStatus(),
										'status' => Option::getByKey( $prev_p_obj->getStatus(), $prev_p_obj->getOptions('status') ),
										'type_id' => $prev_p_obj->getType(),
										'type' => Option::getByKey( $prev_p_obj->getType(), $prev_p_obj->getOptions('type') ),
										'branch_id' => $prev_p_obj->getPunchControlObject()->getBranch(),
										'branch' => Option::getByKey( $prev_p_obj->getPunchControlObject()->getBranch(), $branch_options ),
										'department_id' => $prev_p_obj->getPunchControlObject()->getDepartment(),
										'department' => Option::getByKey( $prev_p_obj->getPunchControlObject()->getDepartment(), $department_options ),
										);

			}

			if ( isset($punch_data) ) {
				$users[] = array(
									'id' => $user->GetId(),
									'first_name' => $user->getFirstName(),
									'last_name' => $user->getLastName(),
									'full_name' => $user->getFullName(),
									'home_email' => $user->getHomeEmail(),
									'punch' => $punch_data

								);
			}
			unset($punch_data);
		}

		if ( isset($users) ) {
			$smarty->assign_by_ref('users', Sort::Multisort($users,'punch', 'branch') );
		}

		$smarty->assign_by_ref('sort_column', $sort_column );
		$smarty->assign_by_ref('sort_order', $sort_order );

		$smarty->assign_by_ref('paging_data', $pager->getPageVariables() );

		break;
}
$smarty->display('report/ActiveShiftList.tpl');
?>